% loesungen.m
% Kapitel 3: Eingabe und Ausgabe in MATLAB
%            Lsungen zu den bungsaufgaben

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 3.7.1 Harmonisches Mittel
%        siehe auch Datei mittelwerte5.m

clear

n      = [];                 % Leerer Vektor fr Lnge der Datenvektoren
arithm = [];                 % Leerer Vektor fr Arithmetisches Mittel
geom   = [];                 % Leerer Vektor fr Geometrisches Mittel
harmon = [];                 % Leerer Vektor fr Harmonisches Mittel
k      = 0;                  % Zhler fr bearbeitete Datenstze

disp (' ')
while 1
    x = input ('Geben Sie einen Datenvektor ein: ');
    if length(x)==0          % Alternativ: if isempty (x),
        break                % Abbruch bei leerer Eingabe
    end
    n = [n length(x)];       % Lnge des Datenvektors anhngen
    k = length(n);           % Zhler fr bearbeitete Datenstze
    [arithm(k), geom(k), harmon(k)] = mittelwerte5 (x);  % Funktion...
end

disp (' ')
disp (['Es wurden die Mittelwerte fr ', num2str(k), ' Datenstze berechnet.'])
disp ('                               Arithmetisch Geometrisch Harmonisch')
disp (' ')

ausgabe = sprintf (['Datensatz %2d mit %3d Werten:   ', ...
                   'A = %5.2f    G = %5.2f   H = %5.2f\n'], ...
                   [(1:k); n; arithm; geom; harmon]);
                   % Vektor fr sprintf: Je Datensatz eine Spalte
disp (ausgabe)

pause
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 3.7.2 Einschwingvorgang

zeit = 0:200;                      % Zeit [s]
F    = 0.05;                       % Frequenz [Hz]
T    = 50;                         % Dmpfungszeitkonstante [s]

huellkurve = exp (-zeit/T);
schwingung = cos (2*pi*F*zeit) .* huellkurve;

figure (2)
plot (zeit, schwingung, 'b-')
hold on
plot (zeit, huellkurve, 'r--')
plot (zeit, -huellkurve, 'g-.')
plot ([0 T T], [-1 0 -1], 'k')    % Markierung Zeitkonstante

xlabel ('Zeit [s]')
ylabel ('Amplitude')
title  (' Exponentiell abklingende Schwingung')
legend ('Schwingung', 'obere Hllkurve', 'untere Hllkurve', 1)
text   (T, -0.75, '  Zeitkonstante')

pause
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 3.7.3 Gau-Glocke

x = -3:0.25:3;                          % x-Vektor (Zeilenvektor)
y = -4:0.25:4;                          % y-Vektor (Spaltenvektor)
[X, Y] = meshgrid (x, y);               % Matrizen der x- und y-Werte
A = X.^2 + Y.^2;                        % Matrix der Abstandsquadrate

sigma = 1;                              % Glttungsfaktor
Z = exp (-A ./ (2*sigma));              % Gau-Funktion

figure (3)
    surf (X, Y, Z)                      % 3D-Plot
    axis ([-3 3 -4 4 0 1]) 
    title ('Gau-Glocke') 

figure (4);
    pcolor (X, Y, Z);                   % Plot mit pcolor
    axis ([-3 3 -4 4]);
    title ('Gau-Glocke: pcolor');

figure (5);
    mesh (X, Y, Z)                      % Plot mit mesh
    axis ([-3 3 -4 4 0 1]);
    title ('Gau-Glocke: mesh')

pause
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 3.7.4 Spirale und Doppelhelix

t = 1:0.05:7;                           % Laufvariable
x = cos (2*pi*t) ./ t;
y = sin (2*pi*t) ./ t;
z = log (t);                            % Gleichmige Steigung

figure (6)
subplot (121)                           % Spirale
    plot3 (x, y, z) 
    view (150, 30)                      % Plot um 180 drehen
    axis ([-1 1 -1 1 0 2])
    box on
    grid off
    title ('Spirale')

subplot (122)                           % Doppelhelix
    surf ([x; -x], [y; -y], [z; z])     % gedrehte Spirale mit -x, -y
    view (150, 30)                      % Plot um 180 drehen
    axis ([-1 1 -1 1 0 2])
    box on
    grid off
    title ('Doppelhelix')

pause
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 3.7.5 Funktion "geradevek"
%        siehe auch Datei geradevek.m

geradevek

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
